/*
 * COMP : comparaison octet par octet de fichiers
 * Utilisation: comp fichier1 fichier2
 *
 */

#include <stdio.h>
#include <windows.h>
#include <string.h>

#define TailleMax 800000 /* taille du buffer */

HANDLE hFichier1,hFichier2; /* Handle des fichiers */

HANDLE LoadFile(LPSTR pszFileName)
{
      return CreateFile(pszFileName, GENERIC_READ, FILE_SHARE_READ, NULL,
      OPEN_EXISTING, 0, 0);
}

void Differents()
{
         printf("\nLes fichiers sont differents !\n");
         Ferme();
         exit();
}
void Nimportequoi()
{
     printf("\nN'importe quoi !!!\n");
     printf("Les fichiers sont forcement identiques.\n");
     exit();
}

void Utilisation()
{
     printf("\nUtilisation:\nCOMP fichier1 fichier2\n");
     printf("Pour les noms de fichier avec des espaces utilisez des guillemets\n");
     exit();
}

void ErreurFichier(char NomF[])
{
 printf("\nLe fichier %s n'existe pas !\n",NomF);
 exit();
}

void Ferme()
{
  CloseHandle(hFichier1);
  CloseHandle(hFichier2);
  return;
}

int main(int argc, char *argv[])
{
DWORD TailleF1, TailleF2; /* Taille des fichiers */
DWORD nb_octets; /* Taille du buffer pour les fichiers */
BOOL OK1, OK2;
char Buffer1[TailleMax], Buffer2[TailleMax];
int i;
/* char val1,val2 */
DWORD nblus1, nblus2;
   if (argc!=3)    /* manque des paramtres */
   {
      Utilisation();  /* affiche une aide */
   }
  hFichier1=LoadFile(argv[1]);
  if (hFichier1==INVALID_HANDLE_VALUE) /* Fichier non trouv */
  {
      ErreurFichier(argv[1]);
      /* return 0; */
  }
  if (strncmp(argv[1],argv[2], 255)==0) /* comparaison d'un fichier  lui-mme */
  {
      Ferme();
      Nimportequoi();
  }
  hFichier2=LoadFile(argv[2]);
  if (hFichier2==INVALID_HANDLE_VALUE) /* Fichier non trouv */
  {
      ErreurFichier(argv[2]);
      /* return 0; */
  }
  TailleF1=GetFileSize(hFichier1, NULL); /* on rcupre la taille des fichiers */
  TailleF2=GetFileSize(hFichier2, NULL);
  printf("\n->%s: %.2f Ko",argv[1], (float) TailleF1/1024); /* affichage de la taille en Ko*/
  printf("\n->%s: %.2f Ko",argv[2], (float) TailleF2/1024);
  if (TailleF1!=TailleF2) {
     Differents();
  }
  printf("\nComparaison en cours...");
  do {
     if (TailleF1<=TailleMax) nb_octets=TailleF1;
     else
      {
      nb_octets=TailleMax;
      }
      TailleF1=TailleF1-nb_octets;
      OK1=ReadFile(hFichier1, &Buffer1, nb_octets, &nblus1, NULL);
      OK2=ReadFile(hFichier2, &Buffer2, nb_octets, &nblus1, NULL);
      for (i=0; i<nb_octets; i++)
      {
      if (Buffer1[i]!=Buffer2[i])
         {
         Differents();
         }
      }
  }
  while (TailleF1!=0);
  printf("\nLes fichiers sont identiques");
  Ferme();
1  return 0; /* Ciao */
}
